
class Node(val el: String, var next: Node, var previous: Node)

class DoublyLinkedList {
  private var front = new Node(null, null, null)
  private var rear = new Node(null, null, front)
  front.next = rear

  override def toString: String = {
    val s = new StringBuilder
    s ++= "["
    var p = front.next
    while (p != rear) {
      s ++= p.el.toString
      if (p.next != rear)
        s ++= ","
      p = p.next  
    }
    s ++= "]"
    s.toString
  }

  def first: Node = {
    if (front.next == rear)
      throw new NoSuchElementException
    else
      front.next
  }

  def last: Node = {
    if (rear.previous == front)
      throw new NoSuchElementException
    else
      rear.previous
  }
   
  def remove(n: Node) {
    n.previous.next = n.next
    n.next.previous = n.previous
  }

  def insertAfter(n: Node, el: String) {
    n.next = new Node(el, n.next, n)
    n.next.next.previous = n.next
  }

  def prepend(el: String) = insertAfter(front, el)

  def append(el: String) = insertAfter(rear.previous, el)

  def length: Int = {
    var count = 0
    var p = front.next
    while (p != rear) {
      count += 1
      p = p.next
    }
    count
  }
}
